C
C
      FUNCTION MCIHAD(MCIND)
C**********************************************************************
C
C    CALCULATION OF THE PARTICLE INDEX ACCORDING TO THE PDG PROPOSAL.
C    MCIHAD PARTICLE NUMBER AS IN DECAY, BAMJET, HADEVT, FLUKA ETC.
C    MCIND  PDG PARTICLE NUMBER
C
C**********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C
      PARAMETER (NMAXD=100)
      COMMON /DEBUG/ IDEB(NMAXD),KSPOM,KHPOM,KSREG,KHDIR,KACCEP,
     &  KSTRG,KHTRG,KSLOO,KHLOO,KSDPO,KHDPO,KEVENT,KSOFT,KHARD
C
      COMMON /HAMCIN/ IAMCIN(187)
C
C  search for hadron
      DO 10 I=1,187
        IH=I
        IF (IAMCIN(I).EQ.MCIND) GOTO 20
 10   CONTINUE
C  check parton?
      MCIHAD = 0
      MI = ABS(MCIND)
      IF((MI.LE.6).OR.(MI.EQ.21).OR.(MI.EQ.9)) RETURN
      IF((MI.EQ.1103).OR.(MI.EQ.2101).OR.(MI.EQ.2103)
     &   .OR.(MI.EQ.2203)) RETURN
      IF((MI.EQ.3101).OR.(MI.EQ.3103).OR.(MI.EQ.3201)
     &   .OR.(MI.EQ.3203).OR.(MI.EQ.3303)) RETURN
C  unknown particle
      IF(IDEB(71).GE.0) THEN
        WRITE(6,'(/1X,A,I8,/)')
     &    'MCIHAD:WARNING:NO HADRON FOUND FOR PARTICLE CODE: ',
     &    MCIND
      ENDIF
      IH = 99999
 20   CONTINUE
      MCIHAD=IH
C
      RETURN
      END
