C
C
       DOUBLE PRECISION FUNCTION PLBEK1(X)
C**********************************************************************
C
C      Modified Bessel Function K1
C
C**********************************************************************
       IMPLICIT DOUBLE PRECISION (A-H,O-Z)       
C      
       IF (X .LT. 2.D0) THEN
         Y = X**2/4.D0
         PLBEK1 = 
     &     (LOG(X/2.D0)*PLBEI1(X))+(1.D0/X)*(1.D0+Y*(0.15443144D0
     &     +Y*(-0.67278579D0+Y*(-0.18156897D0+Y*(-0.1919402D-1
     &     +Y*(-0.110404D-2+Y*(-0.4686D-4)))))))
       ELSE
         Y=2.D0/X
         PLBEK1 = 
     &     (EXP(-X)/SQRT(X))*(1.25331414D0+Y*(0.23498619D0
     &     +Y*(-0.3655620D-1+Y*(0.1504268D-1+Y*(-0.780353D-2
     &     +Y*(0.325614D-2+Y*(-0.68245D-3)))))))
       ENDIF
       END
