C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C---FILL HEADER RECORD OF COMMON HEPEVT
C
      SUBROUTINE HSHEAD
      IMPLICIT DOUBLE PRECISION (A-H,M,O-Z)
C---------------------------------------------------------------------
#include "rghsoptn.inc"
#include "rghsunts.inc"

      COMMON /VGASIO/ NINP,NOUTP
      COMMON /HSVGLP/ NPOVEG,NUMINT,NPHYP
      COMMON /HSRDIO/ ISDINP,ISDOUT
      COMMON /HSPARL/ LPAR(20),LPARIN(12),IPART
      COMMON /HSNUME/ SIGTOT,SIGTRR,SIGG(20),SIGGRR(20),NEVENT,NEVE(20)
      COMMON /HSELAB/ SP,EELE,PELE,EPRO,PPRO
      COMMON /HSPARM/ POLARI,LLEPT,LQUA
      COMMON /HSGSW/  SW,CW,SW2,CW2
     *              ,MW,MZ,MH,ME,MMY,MTAU,MU,MD,MS,MC,MB,MT
     *              ,MW2,MZ2,MH2,ME2,MMY2,MTAU2,MU2,MD2,MS2,MC2,MB2,MT2
      COMMON /PYSTFUC/ PYSTOP,PYSLAM,NPYMOD,NPYMAX,NPYMIN
      REAL           PYSTOP,PYSLAM
      COMMON /HSCUTS/ XMIN,XMAX,Q2MIN,Q2MAX,YMIN,YMAX,WMIN,GMIN
      COMMON /HSIRCT/ DELEPS,DELTA,EGMIN,IOPEGM
#include "chepevt.inc"
      DIMENSION NOW(8)

      NEVHEP=-1
C---RUN AND GENERATOR'S IDENTIFIER
      ISTHEP(1)=1
      IDHEP(1)=0
C---DATE AND TIME
c      CALL DATIM(NOW)
      DO 10 INW=1,8
   10 NOW(INW)=0
      JMOHEP(1,1)=NOW(6)+NOW(7)*100+(NOW(8)-1900)*10000
      JMOHEP(2,1)=NOW(3)+NOW(4)*100+NOW(5)*10000
C---VERSION NUMBER AND DATE OF LAST CHANGE
      JDAHEP(1,1)=0404
      JDAHEP(2,1)=930813

C---REAL PARAMETERS FROM INPUT AND HSPRLG
      PHEP(1,2)=EELE
      PHEP(1,3)=POLARI
      PHEP(1,4)=EPRO
      PHEP(1,5)=XMIN
      PHEP(1,6)=XMAX
      PHEP(1,7)=YMIN
      PHEP(1,8)=YMAX
      PHEP(1,9)=Q2MIN
      PHEP(1,10)=WMIN
      PHEP(1,11)=EGMIN
      PHEP(1,12)=MW
      PHEP(1,13)=MZ
      PHEP(1,14)=MH
      PHEP(1,15)=MT

C---OPTION FLAGS
      ISTHEP(2)=LLEPT
      ISTHEP(3)=ICUT
      DO 20 I=1,12
   20 ISTHEP(I+3)=LPARIN(I)
      ISTHEP(16)=IPART
      ISTHEP(17)=NPYMIN
      ISTHEP(18)=NPYMAX
      ISTHEP(19)=LUNIN
      ISTHEP(20)=LUNOUT
      ISTHEP(21)=LUNTES
      ISTHEP(22)=LUNRND
      ISTHEP(23)=LUNDAT
      ISTHEP(24)=NINP
      ISTHEP(25)=NOUTP
      DO 30 I=1,5
   30 ISTHEP(25+I)=INT2(I)
      DO 40 I=1,15
   40 ISTHEP(30+I)=INT3(I)
      ISTHEP(46)=NPOVEG
      ISTHEP(47)=NUMINT
      ISTHEP(48)=NPHYP
      DO 50 I=1,5
   50 ISTHEP(48+I)=ISAM2(I)
      DO 60 I=1,15
   60 ISTHEP(53+I)=ISAM3(I)
      ISTHEP(69)=IOPLOT
      ISTHEP(70)=IPRINT
      ISTHEP(71)=ISDINP
      ISTHEP(72)=ISDOUT
      ISTHEP(73)=NEVENT
      NHEP=73

      RETURN
      END

