/* This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/



//RunMake - this class runs the make.
//(C)2000-2001 Mark Beynon
//mark@jpedit.co.uk
//http://www.jpedit.co.uk

package com.make;

import bsh.*;

//import java.awt.*;
import javax.swing.JTextArea;

import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.BufferedReader;

import com.jpe.jpe;
import com.utils.*;

// input: win and dir to act


public class RunMake implements Runnable
{

        private jpe win;
        private Utils Utils = new Utils(win);
        private String fileSep = System.getProperty("file.separator");
        private boolean javacerror = false;
        private Thread thread;
        private static String diract="";

	public RunMake(jpe win, String dir)
	{
		super();
		this.win     = win;
                diract= dir;
  }


	private void killThread()
	{
		win.stopMakeThread();
		//this.destroy();
	}

	public void run()
	{




		String line = new String();
                InputStreamReader inp;
                InputStreamReader inplog; 
		BufferedReader bufred;
		String gap = " ";
		JTextArea jtacomp = new JTextArea();
		Process ps = null;

                  // remove log file 
                  String logfile=diract+File.separator+"install.log";
                  File ff1=new File(logfile);
                  boolean bff1=ff1.delete();
                  // clear log messages
                  win.ClearLogMessages();

                 String sh = "bash"; String cop = "-c";
                 String cmd0 = "make -C "+diract+" > "+ logfile;
                 String[] exe0 = new String[] {sh, cop, cmd0};
                 // System.out.println("Debug "+cmd0);
			try
			{
				ps = Runtime.getRuntime().exec(exe0);

	                        inp = new InputStreamReader(ps.getErrorStream());
                              //  inplog= new InputStreamReader (ps.getInputStream());
                              // inp = new InputStreamReader (ps.getInputStream());

				bufred = new BufferedReader(inp);

				while((line=bufred.readLine())!=null)
				{
					jtacomp.append(line + "\n");
				}
					inp.close();
				  bufred.close();
			}
			catch (Exception err)
			{
	    	System.out.println("error running interpreter" + err.getMessage ());
	    	Utils.userMessage("Error", "An error has occured, please see error log.", 1);
	    	Utils.writeErrorLog("error running interpreter" + err.getMessage());
	        } 
	    finally
	    {
	      ps = null;
	      inp = null;
		    bufred = null;
	    }

			win.clearConsole();
			win.setConsole(cmd0 +"\n" + jtacomp.getText() + "Operation complete");

                        killThread();
                        // load log file 
                        win.LoadLogMessages( logfile );


  }





}




