#!/bin/csh -f 

set DIR=`pwd`



echo "---> Check CLHEP installation"

echo "*************" 
echo RunMC directory   $RUNMC
echo Current directory $DIR
echo "*************"

echo "---> Make  KTjets C++ library using RunMC inviroment settings"
echo "---> No RunMC code is used in this case.."

echo " "

cd $RUNMC/main/physics/ktjet/build 
     make -f Makefile clean
     make -f Makefile


cd $DIR
make -f Makefile

echo " "
echo "Now run test program testCLHEP.."

chmod 755 $DIR/testCLHEP
nohup $DIR/testCLHEP

rm -f $DIR/testCLHEP
rm -f $DIR/testCLHEP.o 

echo
echo "**********************************************************"
echo "If you do not see any errors, the CLHEP installation is OK "
echo "**********************************************************"
