      SUBROUTINE meoffsh(WT1)
      IMPLICIT None
C
C    PHOTON GLUON ----> Q Q_BAR
C
C         P1(G)-----//////--------Q1(C)
C                  ////////
C         P2(PH)-----//////--------Q2(CBAR)
C
C

#include "caslujets.inc"
#include "caspara1.inc"
#include "caspara.inc"
#include "casluco.inc"
#include "caspara5.inc"
#include "caspart.inc"
#include "casgki.inc"
#include "casshwr.inc"
#include "casmult.inc"
#include "casscal.inc"
      Integer IGENFL,IMEPHI
      COMMON/GENWEI/IGENFL,IMEPHI
      DOUBLE PRECISION K1K2,K1P2,K1P3,K1P4,K2P1,K2P3,K2P4,K12,K22
      DOUBLE PRECISION P1P2,P1P3,P1P4,P2P3,P2P4,M2,PT2Q
      Double Precision XPQ1(-6:6),XPQ2(-6:6),SFSCAL1,SFSCAL2,STMAX
      DOUBLE PRECISION DSHN(4),DSH(4)
      Double Precision DScale
      Real scale
      Double Precision CUT
c      DATA CUT /1.d-10/
c      DATA CUT /1.d-3/
      DATA CUT /1.d-6/ ! as smallx
      Double Precision Sfcut
      DATA Sfcut /1.d-3/ 
c      DATA Sfcut /1.d-9/ 
	
      Integer I,KIA1,KIA2,KF1,KF2,Kin1,Kin2
      Double Precision QF2,alpha_s,qg2,qg1,sh,th,uh,wt1,sum2,wtg
      Double Precision cab,cabB,SH_NEW,pcm_fin,cos_fin,cphi,cphio,test
      Double Precision E1,E2,Aab,Anab,yph,yph_bar,xsi_hard,aL,epsilon
      Double Precision alph_em,pcm_new,alphas,nq

      Double Precision dot,dot1,dcasrn
      Double Precision sL,rt,ru
      Double Precision Del,Nc
      Double Precision rap1,rap2,rapp,ptstm,zz
      Integer npfin
      Integer IQBAR
      Integer  ikincut,Ipgg,ns_sel
      Real QG0
      COMMON /GLUDAT/QG0,ikincut,Ipgg,ns_sel
	
	Double Precision QQg,lambda
	Double Precision Qscal
	Integer Iqqbar
	Common/GLUDAT2/Qscal,Iqqbar
c      Data IQBAR/1/
c      Data IQBAR/2/

      Data Nc/3.d0/
      Logical ltest
c      data ltest/.true./
      data ltest/.false./
      Logical first
      data first/.true./
c     call pylist(1)
      IQBAR = Iqqbar
      IF(INTER.EQ.2) THEN
         write(6,*) ' INTER = 2 not implemented for meoffsh'
         STOP
      ENDIF
      IF(IPRO.EQ.11) THEN
c	   write(6,*) kpa
         QF2 = DFLOAT(PYCHGE(KPA))**2/9.D0
         NQ = 1d0
      ELSE
         QF2=2.D0/3.D0
         NQ = 3d0
      ENDIF
      NPFIN = N
c	call pylist(1)
      SH = 2.D0 * AM(1)**2 + 2.D0 * DOT1(NF1,NF2)
      WT1 = 0.d0
      IF(SH.LE.0.) RETURN
c boost  cms
      CALL PYROBO(0,N,0.D0,0.D0,CM(1)/CM(4),CM(2)/CM(4),CM(3)/CM(4))
      KIA1=N+1
      KIA2=N+2
      KF1=N+3
      KF2=N+4
      Kin1=N+5
      Kin2=N+6
      N=N+6
      DO I=1,4
         P(KIA1,I) = P(NIA1,I)
         P(KIA2,I) = P(NIA2,I)
         P(KF1,I) = P(NF1,I)
         P(KF2,I) = P(NF2,I)
         DSH(I)= P(NIA1,I) + P(NIA2,I)
      ENDDO
      K(KIA1,1)=13
      K(KIA2,1)=13
      K(KF1,1)=13
      K(KF2,1)=13

      K(Kin1,1)=13
      K(Kin2,1)=13
c define incoming particles as massless, to ensure proper cancellation in
c matrix-element
      P(Kin1,4)=Dabs(P(1,3))
      P(Kin1,5)=0
      P(Kin2,4)=Dabs(P(2,3))
      P(Kin2,5)=0
      Do I=1,3
         P(Kin1,I)=P(1,I)
         P(Kin2,I)=P(2,I)
      enddo
c
      if(ltest) then
         SH_NEW = DOT(DSH,DSH)
         goto 10
      endif
      P(KIA1,3) = 0.5d0*(P(KIA1,3)-P(KIA1,4))
      P(KIA1,4) = DABS(P(KIA1,3))
      P(KIA2,3) = 0.5d0*(P(KIA2,3)+P(KIA2,4))
      P(KIA2,4) = DABS(P(KIA2,3))

      IF(ICCFM.EQ.0) Then
	   If(ires(1).eq.1) then
            P(KIA1,1) = 0D0
            P(KIA1,2) = 0D0
         endif
	   If(ires(2).eq.1) then
            P(KIA2,1) = 0D0
            P(KIA2,2) = 0D0
         endif
      ENDIF

      DO I=1,4
         DSHN(I)= P(KIA1,I) + P(KIA2,I)
      ENDDO
      SH_NEW = DOT(DSHN,DSHN)
      IF(SH_NEW.LE.4.d0*AM(1)**2) GOTO 20

      CALL PYROBO(0,0,0.D0,0.D0,-DSH(1)/DSH(4), -DSH(2)/DSH(4), -DSH(3)
     +/DSH(4))
      PCM_FIN=SQRT(P(NF1,4)**2 - AM(1)**2)
      COS_FIN=P(NF1,3)/PCM_FIN
      CALL PYROBO(0,0,0.D0,0.D0,DSH(1)/DSH(4) ,DSH(2)/DSH(4), DSH(3)/
     +DSH(4))
      CALL PYROBO(0,0,0.D0,0.D0,-DSHN(1)/DSHN(4), -DSHN(2)/DSHN(4),
     +-DSHN(3)/DSHN(4))

      P(KF1,4) = 0.5d0*DSQRT(SH_NEW)
      PCM_NEW=SQRT(P(KF1,4)**2 - AM(1)**2)
      P(KF1,3) =PCM_NEW*COS_FIN
      IF(IMEPHI.EQ.0) THEN
         cphi=cos(2.d0*PI*dcasrn())
         cphio = cphi
      ELSEIF(IMEPHI.EQ.1) THEN
         cphi=cphio
      ENDIF
      P(KF1,1) =DSQRT(PCM_NEW**2-P(KF1,3)**2)*cphi
      P(KF1,2) = DSQRT(PCM_NEW**2-P(KF1,3)**2)*dsqrt(1.d0-cphi**2)
      DO I=1,4
         P(KF2,I) = P(KIA1,I) + P(KIA2,I) - P(KF1,I)
      ENDDO

      CALL PYROBO(0,0,0.D0,0.D0,DSHN(1)/DSHN(4) ,DSHN(2)/DSHN(4),
     +DSHN(3)/DSHN(4))

   10 continue

      K1K2 = DOT1(KIA1,KIA2)
      K1P2 = DOT1(KIA1,Kin2)
      K1P3 = DOT1(KIA1,KF2)
      K1P4 = DOT1(KIA1,KF1)
      K2P1 = DOT1(KIA2,Kin1)
      K2P3 = DOT1(KIA2,KF2)
      K2P4 = DOT1(KIA2,KF1)
      K12 = DOT1(KIA1,KIA1)
      K22 = DOT1(KIA2,KIA2)
      P1P2 = DOT1(Kin1,Kin2)
      P1P3 = DOT1(Kin1,KF2)
      P1P4 = DOT1(Kin1,KF1)
      P2P3 = DOT1(Kin2,KF2)
      P2P4 = DOT1(Kin2,KF1)
      M2 = AM(1)**2
      TH = AM(1)**2 - 2.D0 * DOT1(KIA1,KF1) + K12
      UH = AM(1)**2 - 2.D0 * DOT1(KIA2,KF1) + K22
      SH = K12 + 2.D0 * DOT1(KIA1,KIA2) + K22
      test=Sh_new+th+uh-2*AM(1)**2-K12-K22
	
	
      if(abs(test).gt.1e-5) then
         write(6,*) ' sh+th+uh ,m**2 ',Sh_new+th+uh,2*AM(1)**2+K12+
     +   K22,AM(1)
         write(6,*) ' sh+th+uh-m**2 ',Sh_new+th+uh-2*AM(1)**2-K12-
     +   K22
      endif
C Catani npb 366 (1991) 135
      E1 = -K12/M2
      E2 = -K22/M2
      AL=0d0
c      IF(E2.GT.CUT) write(6,*) ' meoffsh ',E1,E2,CUT
      IF(E1.LT.CUT.AND.E2.LT.CUT) THEN
C all incoming partons are on mass shell
C eq B23,B24
         Aab = K1K2/K1P4/K1P3*((K1P3**2 + K1P4**2)/K1K2 + 2D0*M2*
     +   (1D0 - M2*K1K2/2D0/K1P4/K1P3))
         Anab = -2D0/K1K2*((K1P3**2 + K1P4**2)/K1K2 + 2D0*M2*(1D0 -
     +   M2*K1K2/2D0/K1P4/K1P3))
      ELSEIF(E1.LT.CUT.AND.E2.GT.CUT) THEN
C photoproduction, gluon off mass
C eq. B21, B22
         Aab = (K1K2/K1P2)**2*((P2P3**2+P2P4**2)/K1P4/K1P3 - 2D0*M2/
     +   K22*(P2P4/K1P3-P2P3/K1P4)**2)
         Anab = 0D0
      ELSEIF(E1.GT.CUT.AND.E2.LT.CUT) THEN
C DIS, gluon on mass
C eq. B21, B22
         Aab = (K1K2/K2P1)**2*((P1P3**2+P1P4**2)/K2P4/K2P3 - 2D0*M2/
     +   K12*(P1P4/K2P3-P1P3/K2P4)**2)
         Anab = 0D0
      ELSEIF(E1.GT.CUT.AND.E2.GT.CUT) THEN
C DIS, gluon off mass
C eq B13,B14
         Aab = 4D0*(K1P2*K2P1/P1P2**2)**2*(P1P2**2/(TH-M2)/(UH-M2) -
     +   1D0/K12/K22*(P1P2+2D0*P1P4*P2P3/(TH-M2)+ 2D0*P1P3*P2P4/(UH-
     +   M2))**2)
         Del = 2D0*P1P2*(2D0*P1P3*P2P4/P1P2 - 2D0*P1P4*P2P3/P1P2 - K12*
     +   P1P4/K2P1 + K22*P2P4/K1P2 + K1P4-K2P4)
         Anab = (K1P2*K2P1/P1P2**2)**2*(4D0*P1P2**2*( -1D0/(TH-M2)/(UH-
     +   M2)-1D0/SH*(1D0/(TH-M2)-1D0/(UH-M2))* (P1P3/K2P1-P2P3/K1P2)+
     +   1D0/SH*P1P2/K2P1/K1P2)+2D0/K12/K22* (P1P2+4D0*P1P4*P2P3/(TH-
     +   M2)-Del/SH)* (P1P2+4D0*P1P3*P2P4/(UH-M2)+Del/SH))
         aL = Aab*(1.d0 -1d0/3d0 - 8d0/3d0/Aab*k2p1**2/p1p2**2*(
     +   (p2p4**2+p2p3**2)/(TH-M2)/(UH-M2) - (2d0*M2 + k12)/k22*
     +   (p2p3/(TH-M2) - p2p4/(UH-M2))**2))
      ENDIF
c	write(6,*) K12,k22,K(nia1,2),nia1,K(nia1,2),nia2
c	call pylist(1)
      QG1 = P(NIA1,1)**2+ P(NIA1,2)**2
      QG2 = P(NIA2,1)**2+ P(NIA2,2)**2
      SFSCAL1 = DABS(QG1)
      SFSCAL2 = DABS(QG2)
c      write(6,*) 'k12 ',k12,' k22 ',k22
c      write(6,*) 'qg1 ',qg1,' qg2 ',qg2
c new scale
      PT2Q = P(KF2,1)**2 + P(KF2,2)**2
      xg_bar =  -qg2/(1.d0-xg)/SSS
      yph = dble(YY)
      yph_bar =  -qg1/(1.d0 - yph)/SSS

	if(sfscal1.le.sfcut) sfscal1=sfcut 
	if(sfscal2.le.sfcut) sfscal2=sfcut 
      xsi_hard = (yph+xg_bar)/(xg+yph_bar)
      if(xsi_hard.le.0) then
c            write(6,*) 'meoffsh xsi ',xsi_hard
c            write(6,*) 'k12 ',k12,' k22 ',k22
c            write(6,*) ' new xg,xg_bar ',xg,xg_bar
c            write(6,*) ' new yph,yph_bar ',yph,yph_bar
      endif
c which of the quarks is closer to the proton:
      rapp = PYP(NPFIN,17)
      rap1 = rapp-PYP(NF1,17)
      rap2 = rapp-PYP(NF2,17)
      zz = q2/yph/sss/xg
      if(rap1.le.rap2) then
         ptstm=dsqrt(dabs(qg1)+P(NF1,5)**2)
      else
         ptstm=dsqrt(dabs(qg2)+P(NF2,5)**2)
      endif

      If(IQBAR.eq.1) then
         stmax = xg*sqrt(xsi_hard*SSS)
      elseif(IQBAR.EQ.2) then
         stmax = ptstm/(1.-zz)
      else
         write(6,*) ' meoffsh. no valid scale selected ',IQBAR
      endif
      IF(FIRST) THEN
	   XG2SF = 0.001
	   SFSCAL2 = 2.
	   STMAX = 5.
         call cauniglu(K(2,2),XG2SF,SFSCAL2,STMAX,XPQ2)
         IQBAR = Iqqbar
         IF(IQBAR.EQ.1) THEN
            write(6,*) ' meoffsh - scale: qq-pair '
         ELSE
            write(6,*) ' meoffsh - scale: q or q_bar '
         ENDIF
	      write(6,*) ' meoffsh - scale for alphas ',Qscal
         FIRST=.FALSE.
      ENDIF
c            write(6,*) 'meoffsh xsi ',xsi_hard,' stmax ',stmax
c            write(6,*) ' new xg,xg_bar ',xg,xg_bar
c            write(6,*) ' new yph,yph_bar ',yph,yph_bar
      CALL PYROBO(0,N,0.D0,0.D0,-CM(1)/CM(4),-CM(2)/CM(4),-CM(3)/CM(4)
     +)

c new scale
c check on scale:
      SCALE = REAL(PT2Q+M2)
      IF(IQ2.EQ.1) THEN
         SCALE = Real(4.D0*M2)
      ELSEIF(IQ2.EQ.2) THEN
         SCALE = Real(SH_NEW)
      ELSEIF(IQ2.EQ.3) THEN
         SCALE = Real(4D0*M2 + PT2Q)
c         SCALE = Real(M2 + PT2Q)
      ELSEIF(IQ2.EQ.4) THEN
         SCALE = Real(Q2)
      ELSEIF(IQ2.EQ.5) THEN
         SCALE = Real(Q2 + PT2Q + 4.D0*M2)
      ELSEIF(IQ2.EQ.6) THEN
         SCALE = Real(DABS(K22))
c this is for testing
      ELSEIF(IQ2.EQ.7) THEN
         sL=2d0*k1p2*k2p1/p1p2
         rt=1d0/th
         ru=1d0/uh
         Scale=real(2d0*(sL*rt*ru)/((sL*rt*ru)**2+rt**2+ru**2))
      ELSE
         WRITE(6,*) ' NO VALID Q2 SCALE. STOP'
         STOP
      ENDIF
	
c	write(6,*) ' scales stmax = ',stmax,' sqrt(scale) = ',sqrt(scale)
c	stmax = sqrt(scale)*scalfa
      Dscale = DBLE(scale)
      alpha_s = ALPHAS(sqrt(dscale))
	QQg = Qg0
	Lambda = 0.2	  
c	alpha_s=12.*3.1415927/(33.-8)
c     &	   /Log(dmax1(Dscale,QQg**2)/Lambda**2)

c         write(6,*) ' new alphas ',alpha_s

      ALPH_EM = ALPH
c      alpha_s = 0.3
c	alph_em = 1./137.
      IF(IRUNAEM.EQ.1) ALPH_EM = PYALEM(Q2)

      IF(K(NIA1,2).EQ.22.AND.K(NIA2,2).EQ.21) THEN
         Cab = 16.D0*PI*PI*ALPHA_S*ALPH_EM*QF2
         CabB = 0D0
         if(stmax.ge.sqrt(sss)) then
            XPQ1(0) = 0.d0
            XPQ2(0) = 0.d0
         else 
c	      write(6,*) xg2sf,sfscal2,stmax
            call cauniglu(K(2,2),XG2SF,SFSCAL2,STMAX,XPQ2)
         endif
         WTG= dble(XPQ2(0))
         epsilon = yph**2/2d0/(1d0-yph+yph**2/2d0)
         if ((Aab - epsilon*AL).le.0) then
cc            write(6,*) ' meoffsh: problem with long. photon:', (Aab -
cc     +      epsilon*AL)/Aab
         endif
c	   write(6,*) 'here entered ',K(NIA1,2),K(NIA2,2),QF2
         Aab = Aab - epsilon*AL
      ELSEIF(K(NIA1,2).EQ.21.AND.K(NIA2,2).EQ.21) THEN
         Cab = 16D0*PI**2*ALPHA_S**2/2D0/NC
         CabB = 16D0*PI**2*ALPHA_S**2/2D0*NC/(NC**2-1D0)
         if(stmax.ge.sqrt(sss)) then
            XPQ1(0) = 0.d0
            XPQ2(0) = 0.d0
         else
            call cauniglu(K(1,2),XG1SF,SFSCAL1,STMAX,XPQ1)
            call cauniglu(K(2,2),XG2SF,SFSCAL2,STMAX,XPQ2)
            Cab  = Cab*NQ
            CabB = CabB*NQ
         endif
         WTG= dble(XPQ1(0)*XPQ2(0))
      ELSEIF(K(NIA1,2).EQ.22.AND.K(NIA2,2).EQ.22) THEN
         Cab = 2D0*(4*PI*ALPH_EM)**2*QF2*QF2*NC
         CabB = 0
         WTG= 1.d0
      ENDIF
c      Aab=1
c	Anab = 1
      SUM2 = Cab*Aab + CabB*Anab
c	Sum2 = 1
c	wtg =1 

C new cut for on-shell DGLAP
	If(Iccfm.eq.0) then
c	   If(ires(1).eq.1.and.(Qg1.gt.(PT2Q+M2))) SUM2 = 0 
	   If(ires(1).eq.1.and.(Qg1.gt.scale*scalfa)) SUM2 = 0 
	   If(ires(1).eq.1.and.(Qg1.gt.STMAX**2)) SUM2 = 0 
c	   If(ires(2).eq.1.and.(Qg2.gt.(PT2Q+M2))) SUM2 = 0 
	   If(ires(2).eq.1.and.(Qg2.gt.scale*scalfa)) SUM2 = 0 
	   If(ires(2).eq.1.and.(Qg2.gt.STMAX**2)) SUM2 = 0 
	Endif

c      Write(6,*) ' meoffsh Cab,Aab,CabB,Anab ',Cab,Aab,CabB,Anab
c      Write(6,*) ' meoffsh Wtg ',Wtg,XG1SF,XG2SF
c      Write(6,*) ' meoffsh Cab,Aab,CabB,Anab ',Cab,Aab,CabB,Anab
      IF(SUM2.LT.0D0) THEN
c     Write(6,*) ' meoffsh Cab,Aab,CabB,Anab ',Cab,Aab,CabB,Anab
c     write(6,*) ' SUM2 ',SUM2
         if(sum2.ne.sum2) then
            write(6,*) ' meoffsh SUM2,xsi_hard ',SUM2,xsi_hard
            Write(6,*) ' meoffsh Cab,Aab,CabB,Anab ',Cab,Aab,CabB,
     +      Anab
            write(6,*) ' meoffsh k12,k22 ',k12,k22
            write(6,*) ' meoffsh th,uh ',th,uh
         endif
         SUM2 = 0D0
      ENDIF
 
      SUM2 = SUM2*WTG

      WT1 = SUM2

      if(sum2.ne.sum2) then

         write(6,*) ' meoffsh xpq(0),alpha_s,alph_em',xpq1(0),xpq2(0),
     +      alpha_s,alph_em
         write(6,*) ' meoffsh SUM2,xsi_hard ',SUM2,xsi_hard
         Write(6,*) ' meoffsh Cab,Aab,CabB,Anab ',Cab,Aab,CabB,Anab
         write(6,*) ' meoffsh k12,k22 ',k12,k22
         write(6,*) ' meoffsh th,uh ',th,uh
         write(6,*) ' P(KIA1) ',(P(KIA1,I),I=1,5)
         write(6,*) ' P(KIA2) ',(P(KIA2,I),I=1,5)
         write(6,*) ' P(KF1) ',(P(KF1,I),I=1,5)
         write(6,*) ' P(KF2) ',(P(KF2,I),I=1,5)

      endif
      CALL PYEDIT(13)
      RETURN
   20 WT1 = 0.d0
      CALL PYEDIT(13)
      RETURN
      END
