C
C
      DOUBLE PRECISION FUNCTION GGFNUC(W,Rho,Gamma)
C**********************************************************************
C
C      differential photonnumber for a nucleus (geometriical model)
C      (without form factor)
C
C*********************************************************************
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      SAVE
C
      PARAMETER (PI = 3.14159265359D0)
C
      WGamma = W/Gamma
      Wphib = WGamma * PLBEK1(WGamma*Rho)
      GGFNUC = 1.D0/PI**2 * Wphib**2
      END
