// ntuple viewer 
// get info on ntuple 
#include<iostream>
#include<fstream>
#include<stdlib.h>

#include <TROOT.h>
#include <TApplication.h>
#include <TTree.h> 
#include <TFile.h> 
#include <TBrowser.h>
#include <TStyle.h>

using namespace std;

int main(int argc, char **argv)
{



   if (argc < 2) { cout << "No input parameters!" << endl; return 0; }

    

 
   TFile *f = new TFile ( argv[1] );
   TTree *t = (TTree*)f->Get(  argv[2] );
 

   if (argc ==  3) { 
   f->ls();
   t->Print(); 
   f->Close();
   return 0;
   }


   // the event loop and execute the next statements.
   TApplication theApp("App", &argc, argv);  
   gROOT->SetStyle("Plain");
   gStyle->SetErrorX(0); // no error bars on X
//   TBrowser* b = new TBrowser("RunMC Browser", f, "Ntuple", 10, 20, 600, 300);
//   b->Show();
   t->StartViewer(); 
   // Here we don't return from the eventloop. "Exit ROOT" will quit the app.
   theApp.Run();

   f->Close();

   return 0;
}
